//------------------------------------------------------------
#include "device.h"
//------------------------------------------------------------
#include <QApplication>
#include <QFile>
#include <QTextStream>
#include <QTextCodec>
#include <QMessageBox>
#include <QProcess>
#include <iostream>
//------------------------------------------------------------
using namespace std;
//------------------------------------------------------------
QList<Device*> Device::devices;
//------------------------------------------------------------
Device::Device(QString filename)
{
	this->file = filename;
	
	QFile file("/etc/mtab");
	if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
	{
		cerr << endl << "Can not open the file: /etc/mtab" << endl;
		qApp->quit();
	}

	QProcess process;
	process.start("df", QStringList() << "-h");
	process.waitForFinished();
	QStringList partList(QString(process.readAllStandardOutput()).split("\n"));

	QRegExp sep("\\s+");
	bool found = false;
	QTextStream in(&file);
	while (!in.atEnd())
	{
		QString line = in.readLine();
		if (line.section(" ", 0, 0).section("/", 2, 2) == filename)
		{
			point = line.section(" ", 1, 1);
			file_system = line.section(" ", 2, 2);
			mounted = true;
			found = true;
			
			full_size = partList.at(partList.indexOf(*(new QRegExp("^/dev/" + filename + ".*")))).section(sep, 1, 1);
			free_size = partList.at(partList.indexOf(*(new QRegExp("^/dev/" + filename + ".*")))).section(sep, 3, 3);
		}
	}
		
	if (!found)
	{
		point = "Not mounted";
		mounted = false;
		full_size = "Unknown";
		free_size = "Unknown";
	}
}
//------------------------------------------------------------
Device* Device::deviceOfFile(QString file)
{
	for (int i = 0; i < Device::devices.count(); i++)
	{
		if (Device::devices[i]->file == file)
			return Device::devices[i];
	}
	return 0;
}
//------------------------------------------------------------
